#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MINDISTANCE 5
#define MAXDISTANCE 30

const int sensorPin = 1;

float readVoltage(){
  // Read voltage value
  // Convert value between 0->1024 in voltage 0->5v
  int val = analogRead(sensorPin);  
  float voltage = val * 5.0;
  voltage /= 1024.0; 

  return voltage;
}

// Basic tab conversion between voltage and distance
float sharpVoltage[] = { 
  3.1, 2.5, 1.84, 1.42, 1.15, 1, 0.85, 0.73, 0.5, 0.4, 0.3 };     
int sharpCms[] = { 
  5, 10, 15, 20, 25, 30, 40, 50, 60, 70, 80 };

//Description:
//  Read voltage on analogic pin and determine distance 
//
//Returns:
//  Above tab index corresponding to distance givng an approximate range
//

int distanceIndex(){
  float voltage = readVoltage();
  
  // if voltage is < 0.3, it is difficult to know if distance is very low or far, we return an unknown value
  if( voltage < 0.3 )
    return -1;
    
  // Return corresponding index
  int index = 0;
  while( sharpVoltage[index] > voltage ){
    index++;
    // if value is above range, we return an unknown value
    if( index == 11 )
      return -1;
  }
  return index;
}


//politica colpito: 
//viaggio rasente al murio di destra, alla minima distanza possibile

void StartRoaming(){

  int sensorDx = distanceIndex();
  int sensorSx = distanceIndex();
  int sensorFront = distanceIndex();
  
  if(sensorFront>MAXDISTANCE){
    advance(100, 100);
  }
  
  if(sensorDx > MINDISTANCE){
    turn_L(25,25);
  }else if (sensorDx < MINDISTANCE){
          turn_R(25,25);       
  }
  
}
