  #define MINDISTANCE 5
  #define MAXDISTANCE 30
  #define FRONTMAXDISTANCE 35
  #define FRONTMINDISTANCE 25
  #define LOWMOVE 25
  #define MEDIUMMOVE 50
  #define HIGHMOVE 100
  #define ERRORDISTANCE 45
  
  #define SENSORPINLEFT 0
  #define SENSORPINFRONT 1
  #define SENSORPINRIGHT 2
  
  //politica non colpito: 
  //viaggio rasente al murio di sinistra, alla minima distanza possibile
  void StartRoaming(){
    
    const int sensorRightPin = SENSORPINRIGHT;
    const int sensorLeftPin = SENSORPINLEFT;
    const int sensorFrontPin = SENSORPINFRONT;
    
    
    //prendo distanze
    int distanceRight = effectiveDistance(sensorRightPin);
    Serial.print("Distanza da destra: ");
    Serial.println(distanceRight);
    int distanceLeft = effectiveDistance(sensorLeftPin);
    Serial.print("Distanza da sinistra: ");
    Serial.println(distanceLeft);
    int distanceFront = effectiveDistance(sensorFrontPin);
    Serial.print("Distanza di fronte: ");
    Serial.println(distanceFront);
    
    //niente davanti, avanzo
    if(distanceFront>MAXDISTANCE && distanceFront<ERRORDISTANCE){
      //Abilito i motori
      start();
      advance(HIGHMOVE, HIGHMOVE);
      //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
      
        //troppo lontano da sinistra, mi avvicino
      if(distanceLeft > MINDISTANCE){
        //Abilito i motori
        start();
        turn_L(LOWMOVE,LOWMOVE);
        advance(MEDIUMMOVE,MEDIUMMOVE);
        //Avanzo x 3 secondi
        delay(3000);
        //mi fermo
        stop();
      }else if (distanceLeft < MINDISTANCE){ //troppo vicino a sinistra, mi allontano
        //Abilito i motori
        start();
        turn_R(LOWMOVE,LOWMOVE); 
        advance(MEDIUMMOVE,MEDIUMMOVE);
        //Avanzo x 3 secondi
        delay(3000);
        //mi fermo
        stop();   
      }
    }
    
    //incrocio: muro di fronte e dx libera
    if(distanceFront<FRONTMAXDISTANCE && distanceRight>MAXDISTANCE){
     //Abilito i motori
      start();
     turn_R(MEDIUMMOVE,MEDIUMMOVE);
     advance(HIGHMOVE,HIGHMOVE);
     //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }else if(distanceFront<FRONTMAXDISTANCE && distanceLeft>MAXDISTANCE){ //muro fronte e sx libera
      //Abilito i motori
      start();
      //sinistra libera
      turn_L(MEDIUMMOVE,MEDIUMMOVE);
      advance(HIGHMOVE,HIGHMOVE);
      //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }else if(distanceFront<FRONTMINDISTANCE){ //muro di fronte troppo vicino
     //Abilito i motori
     start();
     back_off(LOWMOVE,LOWMOVE);
     //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }
  }
  
  //politica colpito: 
  //viaggio rasente al murio di destra, alla minima distanza possibile
  
  void RoamingHit(){
    
    const int sensorRightPin = SENSORPINRIGHT;
    const int sensorLeftPin = SENSORPINLEFT;
    const int sensorFrontPin = SENSORPINFRONT;
  
    int distanceRight = distanceIndex(sensorRightPin);
    int distanceLeft = distanceIndex(sensorLeftPin);
    int distanceFront = distanceIndex(sensorFrontPin);
    
    //niente davanti, avanzo
    if(distanceFront>MAXDISTANCE){
      //Abilito i motori
      start();
      advance(HIGHMOVE, HIGHMOVE);
      //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }
    
    //troppo lontano da dx, mi avvicino
    if(distanceRight > MINDISTANCE){
      //Abilito i motori
      start();
      turn_R(LOWMOVE,LOWMOVE);
      advance(MEDIUMMOVE,MEDIUMMOVE);
      //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }else if (distanceRight < MINDISTANCE){ //troppo vicino a dx, mi allontano
      //Abilito i motori
      start();
      turn_L(LOWMOVE,LOWMOVE);
      advance(MEDIUMMOVE,MEDIUMMOVE);
      //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();   
    }
    
    //incrocio: muro di fronte e dx libera
    if(distanceFront<FRONTMAXDISTANCE && distanceRight>MAXDISTANCE){
     //Abilito i motori
     start();
     turn_R(MEDIUMMOVE,MEDIUMMOVE);
     advance(HIGHMOVE,HIGHMOVE); 
     //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }else if(distanceFront<FRONTMAXDISTANCE && distanceLeft>MAXDISTANCE){ //muro di fronte e sx libera
      //Abilito i motori
      start();
      //sinistra libera
      turn_L(MEDIUMMOVE,MEDIUMMOVE);
      advance(HIGHMOVE,HIGHMOVE);
      //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }else if(distanceFront<FRONTMINDISTANCE){ //troppo vicino davanti, indietreggio
     stop();
     //Abilito i motori
     start();
     back_off(LOWMOVE,LOWMOVE);
     //Avanzo x 3 secondi
      delay(3000);
      //mi fermo
      stop();
    }
    
    
  }
  
  
  
  
  

