  #include <Arduino.h>
  #include <SoftwareSerial.h>
  
  #define MIN 10
  #define MAX 18
  #define FRONTMAX 20
  #define FRONTMIN 5
  #define LOWMOVE 25
  #define MEDIUMMOVE 50
  #define HIGHMOVE 100
  #define ERRORDISTANCE 45
  
  #define ROBOTRELOAD 3000
  
  const int rxPin = 6;
  const int txPin = 7;
  SoftwareSerial xBee = SoftwareSerial(rxPin,txPin);
  int colpito = 0;
  int value;
  int exitValue =0;
  
   const int sensorRightPin = 2;
    const int sensorLeftPin = 0;
    const int sensorFrontPin = 1;
    
    int right;
    int left;
    int front;
  
  
  void setup(){
    
    Serial.begin(9600);
    initMotor();
    initLED();
    pinMode(rxPin, INPUT);
    pinMode(txPin, OUTPUT);
    xBee.begin(9600);
    
  }
  
  void loop(){    
    accensioneLED(); 
    do{   
      while(colpito == 0){
      
      //politica non colpito
        
          xBee.print("Abilito motori \n");
          start();
          xBee.print("Politica non colpito\n");
          RoamingBase();
          delay(1000);
          if(xBee.available()>0 && exitValue == 0){
            value=xBee.read();
            switch(value){
              case '1': xBee.print("Colpito! ");
                        colpito = 1;
                        stop();
                        xBee.print("Attendo... ");
                        delay(ROBOTRELOAD);
                        xBee.print("..riparto! \n"); 
                        break;
              //roaming
              default: xBee.println("Nessun segnale via XBee..");
                        
                       break;
            }      
          }
          xBee.print("Disabilito motori \n");
          stop();
          delay(1000);
//          RoamingBase();
       }
      
      //politica colpito
      
        while(colpito == 1){
          xBee.print("Abilito motori \n");
          start();
          xBee.print("Politica Colpito \n");
           RoamingBase();
           delay(1000);
           if(xBee.available()>0 && exitValue == 0){
            value=xBee.read();
            switch(value){
              case '1': xBee.print("Morto \n");
                        stop();
                        exitValue = 1;
                        colpito = 2;
                         delay(ROBOTRELOAD);
                        break;
              //roaming
              default: xBee.println("Nessun segnale via XBee..");
                       
                       break;
            }      
          } 
          xBee.print("Disabilito motori \n");
          stop();
         delay(1000); 
        }  
        
      
    }while(exitValue == 0);
    while(colpito == 2 && exitValue == 1){
      xBee.print("Dead robots don't walk anymore... \n");
      stop();
      spegnimentoLED();
    }
}


//configurazione if-else ok, non gira bene
void RoamingBase(){
    
    aggiornoDistanze();
    
    if(front > FRONTMIN ){
      if(front > FRONTMAX){
        xBee.print("Avanzo \n");
        
        advance(MEDIUMMOVE, MEDIUMMOVE);
        delay(10000);
        
                
      }
      
      if(front < FRONTMAX){
        if(right > MAX ){
            
            xBee.print("Giro tanto a destra \n");
            
            turn_R(MEDIUMMOVE,MEDIUMMOVE);
            delay(10000);
            advance(MEDIUMMOVE,MEDIUMMOVE);
            delay(4000);
            
            //aggiorno sensori
            //delay(2000);
          }
          
        else{
             
              xBee.print("Giro tanto a sinistra \n");
              
              turn_L(MEDIUMMOVE,MEDIUMMOVE);
              delay(10000);
              advance(MEDIUMMOVE,MEDIUMMOVE);
              delay(4000);
              
              //aggiorno sensori
              //delay(2000);
          }
          
       
        
        
      }      
    }
    if(front <= FRONTMIN){
      xBee.print("Indietreggio \n");
      
      back_off(LOWMOVE, LOWMOVE);
      delay(6000);
      
      //aggiorno sensori
      //delay(2000);
      
    }
    
  }
  
  void aggiornoDistanze(){
   
    xBee.print("Aggiorno le distanze: \n");
    right = effectiveDistance(sensorRightPin);
    xBee.print("Distanza dx: ");
    xBee.print(right);
    xBee.print("\n");
    left = effectiveDistance(sensorLeftPin);
    xBee.print("Distanza sx: ");
    xBee.print(left);
    xBee.print("\n");
    front = effectiveDistance(sensorFrontPin);
    xBee.print("Distanza front: ");
    xBee.print(front );
    xBee.print("\n");
    
  }
  
  void RoamingMiddle(){
    
    aggiornoDistanze();
    
    if(front > FRONTMIN ){
      if(front > FRONTMAX){
        xBee.print("Avanzo \n");
        start();
        advance(MEDIUMMOVE, MEDIUMMOVE);
        delay(3000);  
        stop();
        aggiornoDistanze();  
        delay(1000);  
      }
      
      if(front < FRONTMAX){
        if(right > MAX ){
            start();
            xBee.print("Giro tanto a destra \n");
            turn_R(MEDIUMMOVE,MEDIUMMOVE);
            delay(3000);
            stop();
            aggiornoDistanze();  
            delay(1000); 
          }
          
        else if(left > MAX){
              start();
              xBee.print("Giro tanto a sinistra \n");
              turn_L(MEDIUMMOVE,MEDIUMMOVE);
              delay(3000);
              stop();
              aggiornoDistanze();  
              delay(1000); 
        }
        
        if(left < MIN){
          xBee.print("Mi sposto da sinistra\n");
          start();
          turn_R(LOWMOVE,LOWMOVE);
          delay(2000);
          stop();
          aggiornoDistanze();  
          delay(1000); 
        }
        else if (right < MIN){
          xBee.print("Mi sposto da destra\n");
          start();
          turn_L(LOWMOVE,LOWMOVE);
          delay(2000);
          stop();
          aggiornoDistanze();  
          delay(1000); 
        }
       
        
        
      }      
    }
    if(front <= FRONTMIN){
      xBee.print("Indietreggio \n");
      start();
      back_off(LOWMOVE, LOWMOVE);
      delay(3000);
      stop();
      aggiornoDistanze();  
      delay(1000); 
    }
    
    
  }
