
float readVoltage(int sensor){
  // Read voltage value
  // Convert value between 0->1024 in voltage 0->5v
  int val = analogRead(sensor);  
  float voltage = val * 5.0;
  voltage /= 1024.0; 

  return voltage;
}

// Basic tab conversion between voltage and distance
float sharpVoltage[] = { 3.05, 3, 2.75, 2.35, 2, 1.77, 1.57, 1.4, 1.25, 1.07, 0.97, 0.81, 0.75, 0.65, 0.6, 0.5, 0.4, 0.35, 0.3};     
int sharpCms[] = { 3, 3.75, 4, 5, 6, 7, 8, 9, 10, 12, 14, 16, 18, 20, 22, 25, 30, 35, 40 };

//float sharpVoltage[] = { 
//  3.1, 2.5, 1.84, 1.42, 1.15, 1, 0.85, 0.73, 0.5, 0.4, 0.3 };     
//int sharpCms[] = { 
//  5, 10, 15, 20, 25, 30, 40, 50, 60, 70, 80 };


//Description:
//  Read voltage on analogic pin and determine distance 
//
//Returns:
//  Above tab index corresponding to distance givng an approximate range
//

int distanceIndex(int sensor){
  float voltage = readVoltage(sensor);
  int index=0;
  
  // if voltage is < 0.3, it is far o very near
  if( voltage < 0.3 ){
    return -3;
  }
  // Return corresponding index
  while( sharpVoltage[index] > voltage ){
    index++;
    // if value is above range, we return an unknown value
    if( index == 19 )
      return -3;
  }
  // visto 1 cm più lontano x tutti i valori dispari, eseguo correzione
  
  return index;
}

int effectiveDistance(int sensor){
 int index=distanceIndex(sensor);
 int distance=0;
 distance=sharpCms[index];
 return distance;
}

