#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiiuse.h>
#include <time.h>
#include <ncurses.h>
#include <string.h>

    #include <termios.h>
    #include <unistd.h>
    #include <fcntl.h>



#define ROBOTKILLED 2
#define PLAYERKILLED 1
#define WIIMOTENUMBER 1
#define ALLWIIMOTE 2
#define SEARCHTIME 10
#define PLAYERRELOADTIME 5000
#define ROBOTRELOADTIME 3000



int main (int argc, char * argv []){
	
	clock_t timer;
	clock_t end_timer;
	int shot_permitted=0;
	int player_killed=0;
	int robot_killed=0;
	int robot_hit=0;
	char playername [20];
	char answer;
	char shot;
	int number_of_wiimote=0;
	int connected;
	wiimote** wiimote_player;
	wiimote** wiimote_robot;
	pid_t spykeePID;
	FILE * pFile;
						//	int descrittore_socket_serverFunction;
						//	int descrittore_socket_clientFunction;
						//	int descrittore_socket_player;
						//	int robot_socket;
						//	int player_socket;
						//	char buffer[512];
						//	char messaggio[512]="colpito";
	
	//inizializzazione wiimote_player
	wiimote_player=wiiuse_init(WIIMOTENUMBER);
	number_of_wiimote=wiiuse_find(wiimote_player, WIIMOTENUMBER, SEARCHTIME);
	printf("Ricerca wiimote player...");
	connected=wiiuse_connect(wiimote_player,WIIMOTENUMBER);
	if(connected)
		printf("Connesso a %i wiimote_player di %i trovati.\n",connected, number_of_wiimote);
	else{
		printf("Connessione non riuscita con wiimote del giocatore.\n");
	}
	
	//inizializzazione wiimote_robot
	wiimote_robot=wiiuse_init(WIIMOTENUMBER);
	number_of_wiimote=wiiuse_find(wiimote_robot, WIIMOTENUMBER, SEARCHTIME);
	printf("Ricerca wiimote robot...");
	connected=wiiuse_connect(wiimote_robot,WIIMOTENUMBER);
	if(connected)
		printf("Connesso a %i wiimote_robot di %i trovati.\n",connected, number_of_wiimote);
	else{
		printf("Connessione non riuscita con wiimote robot.\n");
	}
	
	//apertura spykee su processo figlio
	printf("Apertura controllo SpyKee in corso...");
	spykeePID=fork();
	if(spykeePID == 0){
		system("java -jar jSpykee.jar");
		while(!player_killed || robot_hit<ROBOTKILLED){
		}
		return 0;
	}

	//processo padre controllo gioco
	printf("Configurare Spykee con i parametri correnti...");
	do{
		printf("Conferma configurazione s/n : ");
		scanf("%c", &answer);
	}while(answer != 's');
	
	//richiesta inizio gioco
	printf("Vuoi giocare a Laser Game Bot, %s ? s/n " , playername);
	scanf(" %c", &answer);
	if(answer == 'n'){
		return 0;
	}
	
	
	printf("Benvenuto Giocatore!\n Inserisci il tuo nome: ");
	scanf("%*c");
	char *returnValue = fgets(playername, 10, stdin);
	if(returnValue == NULL){
		printf("Errore nella fgets()....");
	}
	printf("Benvenuto %s \n", playername);
	
	// spiegazione del gioco e comandi
	printf("il gioco consiste nel riuscire a colpire 2 volte il robot avversario, senza tuttavia essere colpiti da questo; se vieni colpito anche una sola volta hai perso. \n Ogni volta che spari la tua arma ha un tempo di ricarica (5s), dovrai aspettare prima di poter sparare di nuovo. \n Quando il tuo avversario viene colpito, rimane in standby per un certo tempo (3s), almeno avrai tempo di fuggire. \n I comandi sono...per muoverti, ... per sparare. \n");

	do{
		printf("Sei pronto a cominciare? s/n ");
		scanf(" %c", &answer);
	}while(answer != 's');
	
	
	//inizio gioco
	printf("Che la sfida cominci! ");
	shot_permitted=1;
	printf("premi s per sparare... \n");
	while(robot_hit<ROBOTKILLED || !player_killed){
		
		//polling eventi da wiimote_player
		
		
		if(kbhit()){
			shot=getchar();
			
			/*giocatore spara ma non colpisce il robot*/
			if (shot=='s') {
				printf("BANG!!!");
				if(shot_permitted && !confermacolpo(wiimote_player)){

					/*condizione ricarica arma player*/
					shot_permitted=0;
					printf("Bersaglio mancato! ");
					//ricarica arma
					timer=clock();
					printf("Attendi ricarica arma.. \n");
					do{
						end_timer=clock();
					}while((end_timer-timer)<PLAYERRELOADTIME);
					shot_permitted=1;
					printf("..Ricarica completata \n");
				}
				
			
			/*giocatore spara e colpisce robot*/
							
				if(shot_permitted && confermacolpo(wiimote_player)){
					
					/*condizione ricarica robot se colpito*/
					//xbee x invio stop robot
					robot_hit++;
                   			shot_permitted=0;
					printf("Bersaglio colpito, robot in standby. \n");
					printf("Hai colpito il tuo avversario %d volte. \n", robot_hit);
                    			printf("Attendi ricarica arma.. \n");
					if(robot_hit==ROBOTKILLED){
						robot_killed=1;
						//xbee invio ferma robot
					}
					else{
						//ricarica arma
						timer=clock();
						do{
							end_timer=clock();
							//info ricarica robot
							if(end_timer==ROBOTRELOADTIME){
                                				printf("Il tuo avversario riparte. \n");	
                            				}
						}while((end_timer-timer)<PLAYERRELOADTIME);
						shot_permitted=1;
                                		printf("..Ricarica completata \n");
						
							
					}		
				}
			}
			/*player colpito*/
			
			if(confermacolpo(wiimote_robot)){
				player_killed=PLAYERKILLED;
				//xbee ferma robot
				
			}
			
		}
		
//		if(wiiuse_poll(wiimote_player,1) || wiiuse_poll(wiimote_robot,1)){
		
		//giocatore x sparare preme tastiera (pulsante s)
			
			
//		}
		
	}
	
	//fine del gioco
	if(player_killed){
		printf("%s sei stato colpto, hai perso \n", playername); 
	}
	else{
		if(robot_killed==ROBOTKILLED){
			printf("%s hai distrutto il tuo avversario, hai vinto!!! \n", playername);
		}
	printf("Grazie per aver partecipato!\n");
	wiiuse_cleanup(wiimote_player,ALLWIIMOTE);
	return 0;
	}

}

int confermacolpo(wiimote** wiimote){
	if((**wiimote).ir.num_dots==2){
		if((**wiimote).ir.dot[0].y == (**wiimote).ir.dot[1].y){
			return 1;
		}
		else if((**wiimote).ir.dot[3].y == (**wiimote).ir.dot[0].y){
			return 1;
		}
		else if ((**wiimote).ir.dot[1].y == (**wiimote).ir.dot[2].y){
			return 1;
		}
		else if((**wiimote).ir.dot[2].y == (**wiimote).ir.dot[3].y){
			return 1;
		}
	}
	return 0;
}




    int kbhit(void)
    {
      struct termios oldt, newt;
      int ch;
      int oldf;
      tcgetattr(STDIN_FILENO, &oldt);
      newt = oldt;
      newt.c_lflag &= ~(ICANON | ECHO);
      tcsetattr(STDIN_FILENO, TCSANOW, &newt);
      oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
      fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);
      ch = getchar();
      tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
      fcntl(STDIN_FILENO, F_SETFL, oldf);
      if(ch != EOF)
      {
        ungetc(ch, stdin);
        return 1;
      }
      return 0;
    }
//    int main(void)
//    {
//      while(1){
//    //sezione di codice
//    if(kbhit()) {printf("You pressed '%c'!\n", getchar());break;}
//        printf("Press a key!\n");
//     }
//      return 0;
//    }

//	Lettura fgets da file
//	pFile = fopen ("myfile.txt" , "r");
//   	if (pFile == NULL) perror ("Error opening file");
//   	else {
//     		if ( fgets (playername , 100 , pFile) != NULL )
//       			puts (playername);
//     	fclose (pFile);
//   	}



