#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiiuse.h>
#include <time.h>
#include <ncurses.h>
#include <string.h>

    #include <termios.h>
    #include <unistd.h>
    #include <fcntl.h>
    #include <errno.h>   /* Error number definitions */



#define ROBOTKILLED 2
#define PLAYERKILLED 1
#define WIIMOTENUMBER 1
#define ALLWIIMOTE 2
#define SEARCHTIME 10
#define PLAYERRELOADTIME 5000
#define ROBOTRELOADTIME 3000

void confermaSparoPlayer();
void confermaSparoRobot();
void handle_event(struct wiimote_t* wm);
int confermacolpo(wiimote* wiimote);
void handle_ctrl_status(struct wiimote_t* wm);
short any_wiimote_connected(wiimote** wm, int wiimotes);
int open_port();
int scriviSeriale(int fd);
int settingSeriale();

	clock_t timer;
	clock_t end_timer;
	int shot_permitted=0;
	int player_killed=0;
	int robot_killed=0;
	int robot_hit=0;
	char playername [20];
	char answer;
	char shot;
	wiimote** wiimote_player;
	wiimote** wiimote_robot;
	int seriale;

int main (int argc, char * argv []){
	
	
	int number_of_wiimote=0;
	int connected;
	
	pid_t spykeePID;
	FILE * pFile;
						//	int descrittore_socket_serverFunction;
						//	int descrittore_socket_clientFunction;
						//	int descrittore_socket_player;
						//	int robot_socket;
						//	int player_socket;
						//	char buffer[512];
						//	char messaggio[512]="colpito";
	//inizializzo seriale
	seriale = settingSeriale();
	printf("Idenitficativo porta seriale: %d \n", seriale);
	//inizializzazione wiimote_player
	printf("Ricerca wiimote player...");
	wiimote_player=wiiuse_init(WIIMOTENUMBER);
	number_of_wiimote=wiiuse_find(wiimote_player, WIIMOTENUMBER, SEARCHTIME);;
	connected=wiiuse_connect(wiimote_player,WIIMOTENUMBER);
	if(connected)
		printf("Connesso a %i wiimote_player di %i trovati.\n",connected, number_of_wiimote);
	else{
		printf("Connessione non riuscita con wiimote del giocatore.\n");
	}
	wiiuse_set_leds(wiimote_player[0], WIIMOTE_LED_1);
	
	//inizializzazione wiimote_robot
	printf("Ricerca wiimote robot...");
	wiimote_robot=wiiuse_init(WIIMOTENUMBER);
	number_of_wiimote=wiiuse_find(wiimote_robot, WIIMOTENUMBER, SEARCHTIME);
	connected=wiiuse_connect(wiimote_robot,WIIMOTENUMBER);
	if(connected)
		printf("Connesso a %i wiimote_robot di %i trovati.\n",connected, number_of_wiimote);
	else{
		printf("Connessione non riuscita con wiimote robot.\n");
	}
	wiiuse_set_leds(wiimote_robot[0], WIIMOTE_LED_2);
	
	//apertura spykee su processo figlio
	printf("Apertura controllo SpyKee in corso...");
	spykeePID=fork();
	if(spykeePID == 0){
		system("java -jar jSpykee.jar");
		while(!player_killed || robot_hit<ROBOTKILLED){
		}
		return 0;
	}

	//processo padre controllo gioco
	printf("Configurare Spykee con i parametri correnti...");
	do{
		printf("Conferma configurazione s/n : ");
		scanf("%c", &answer);
	}while(answer != 's');
	
	//richiesta inizio gioco
	printf("Vuoi giocare a Laser Game Bot, %s ? s/n " , playername);
	scanf(" %c", &answer);
	if(answer == 'n'){
		return 0;
	}
	
	
	printf("Benvenuto Giocatore!\n Inserisci il tuo nome: ");
	scanf("%*c");
	char *returnValue = fgets(playername, 10, stdin);
	if(returnValue == NULL){
		printf("Errore nella fgets()....");
	}
	printf("Benvenuto %s \n", playername);
	
	// spiegazione del gioco e comandi
	printf("il gioco consiste nel riuscire a colpire 2 volte il robot avversario, senza tuttavia essere colpiti da questo; se vieni colpito anche una sola volta hai perso. \n Ogni volta che spari la tua arma ha un tempo di ricarica (5s), dovrai aspettare prima di poter sparare di nuovo. \n Quando il tuo avversario viene colpito, rimane in standby per un certo tempo (3s), almeno avrai tempo di fuggire. \n I comandi sono...per muoverti, ... per sparare. \n");

	do{
		printf("Sei pronto a cominciare? s/n ");
		scanf(" %c", &answer);
	}while(answer != 's');
	
	
	//inizio gioco
	printf("Che la sfida cominci! ");
	shot_permitted=1;
	printf("premi s per sparare... \n");
	while(robot_hit<ROBOTKILLED || !player_killed){
		
		//polling eventi da wiimote_player
		while(any_wiimote_connected(wiimote_player, WIIMOTENUMBER)){
		
			if(wiiuse_poll(wiimote_player,WIIMOTENUMBER || kbhit() )){
					shot=getchar();
					switch(wiimote_player[0]->event){
						case WIIUSE_EVENT: handle_event(wiimote_player[0]);
								   break;
						case WIIUSE_STATUS: handle_ctrl_status(wiimote_player[0]);
								    break;
						default: break;
					}
					
			}else if(wiiuse_poll(wiimote_robot,WIIMOTENUMBER)){
					switch(wiimote_robot[0]->event){
						case WIIUSE_EVENT:handle_event(wiimote_robot[0]);
								   break;
						case WIIUSE_STATUS: handle_ctrl_status(wiimote_robot[0]);
								    break;
						default: break;
					}
		     	      }
		}
	}
	
	//fine del gioco
	if(player_killed){
		printf("%s sei stato colpto, hai perso \n", playername); 
	}
	else{
		if(robot_killed==ROBOTKILLED){
			printf("%s hai distrutto il tuo avversario, hai vinto!!! \n", playername);
		}
	printf("Grazie per aver partecipato!\n");
	wiiuse_cleanup(wiimote_player,ALLWIIMOTE);
	return 0;
	}

}

void confermaSparoPlayer(){
	
	if (shot=='s') {
		printf("BANG!!!");
		/*giocatore spara ma non colpisce il robot*/
		if(shot_permitted && !confermacolpo(wiimote_player[0])){
	
			/*condizione ricarica arma player*/
			shot_permitted=0;
			printf("Bersaglio mancato! ");
			//ricarica arma
			timer=clock();
			printf("Attendi ricarica arma.. \n");
			do{
				end_timer=clock();
			}while((end_timer-timer)<PLAYERRELOADTIME);
			shot_permitted=1;
			printf("..Ricarica completata \n");
		}
		/*giocatore spara e colpisce robot*/
		if(shot_permitted && confermacolpo(wiimote_player[0])){
			
			/*condizione ricarica robot se colpito*/
			//xbee invio ferma robot
			int trasmesso = scriviSeriale(seriale);
			printf("Trasmessi %d bytes \n", trasmesso);
			printf("Attendi ricarica arma.. \n");
			robot_hit++;
			shot_permitted=0;
			printf("Bersaglio colpito, robot in standby. \n");
			printf("Hai colpito il tuo avversario %d volte. \n", robot_hit);
			if(robot_hit==ROBOTKILLED){
				robot_killed=1;
				wiiuse_disconnect(wiimote_player[0]);
				wiiuse_disconnect(wiimote_robot[0]);
			}
			else{
				//ricarica arma
				timer=clock();
				do{
					end_timer=clock();
					//info ricarica robot
					if(end_timer==ROBOTRELOADTIME){
	        				printf("Il tuo avversario riparte. \n");	
	    				}
				}while((end_timer-timer)<PLAYERRELOADTIME);
				shot_permitted=1;
	        		printf("..Ricarica completata \n");
				
					
			}		
		}
	}
}

void confermaSparoRobot(){
	/*player colpito*/
	if(confermacolpo(wiimote_robot[0])){
		player_killed=PLAYERKILLED;
		//xbee invio ferma robot
		int trasmesso = scriviSeriale(seriale);
		printf("Trasmessi %d bytes \n", trasmesso);
		wiiuse_disconnect(wiimote_player[0]);
		wiiuse_disconnect(wiimote_robot[0]);		
	}
}

int confermacolpo(wiimote* wiimote){
	if((*wiimote).ir.num_dots==2){
		return 1;
	}
	return 0;
}

/*
	lettura da tastiera senza enter
*/


    int kbhit(void)
    {
      struct termios oldt, newt;
      int ch;
      int oldf;
      tcgetattr(STDIN_FILENO, &oldt);
      newt = oldt;
      newt.c_lflag &= ~(ICANON | ECHO);
      tcsetattr(STDIN_FILENO, TCSANOW, &newt);
      oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
      fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);
      ch = getchar();
      tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
      fcntl(STDIN_FILENO, F_SETFL, oldf);
      if(ch != EOF)
      {
        ungetc(ch, stdin);
        return 1;
      }
      return 0;
    }
//    int main(void)
//    {
//      while(1){
//    //sezione di codice
//    if(kbhit()) {printf("You pressed '%c'!\n", getchar());break;}
//        printf("Press a key!\n");
//     }
//      return 0;
//    }

//	Lettura fgets da file
//	pFile = fopen ("myfile.txt" , "r");
//   	if (pFile == NULL) perror ("Error opening file");
//   	else {
//     		if ( fgets (playername , 100 , pFile) != NULL )
//       			puts (playername);
//     	fclose (pFile);
//   	}

/*
	comandi wiiuse
*/

void handle_event(struct wiimote_t* wm) {
	printf("\n\n--- EVENT [id %i] ---\n", wm->unid);

	/* if a button is pressed, report it */
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_A)) {
		printf("A pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_B)) {
		printf("B pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_UP)) {
		printf("UP pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_DOWN))	{
		printf("DOWN pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_LEFT))	{
		printf("LEFT pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_RIGHT))	{
		printf("RIGHT pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_MINUS))	{
		printf("MINUS pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_PLUS))	{
		printf("PLUS pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_ONE)) {
		printf("ONE pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_TWO)) {
		printf("TWO pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_HOME))	{
		printf("HOME pressed\n");
	}

	/*
	 *	Pressing minus will tell the wiimote we are no longer interested in movement.
	 *	This is useful because it saves battery power.
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_MINUS)) {
//		wiiuse_motion_sensing(wm, 0);
//	}

	/*
	 *	Pressing plus will tell the wiimote we are interested in movement.
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_PLUS)) {
//		wiiuse_motion_sensing(wm, 1);
//	}

	/*
	 *	Pressing B will toggle the rumble
	 *
	 *	if B is pressed but is not held, toggle the rumble
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_B)) {
//		wiiuse_toggle_rumble(wm);
//	}

	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_UP)) {
		wiiuse_set_ir(wm, 1);
	}
	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_DOWN)) {
		wiiuse_set_ir(wm, 0);
	}

	/*
	 * Motion+ support
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_ONE)) {
//		if (WIIUSE_USING_EXP(wm)) {
//			wiiuse_set_motion_plus(wm, 2);    // nunchuck pass-through
//		} else {
//			wiiuse_set_motion_plus(wm, 1);    // standalone
//		}
//	}

//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_TWO)) {
//		wiiuse_set_motion_plus(wm, 0); // off
//	}

	/* if the accelerometer is turned on then print angles */
//	if (WIIUSE_USING_ACC(wm)) {
//		printf("wiimote roll  = %f [%f]\n", wm->orient.roll, wm->orient.a_roll);
//		printf("wiimote pitch = %f [%f]\n", wm->orient.pitch, wm->orient.a_pitch);
//		printf("wiimote yaw   = %f\n", wm->orient.yaw);
//	}

	/*
	 *	If IR tracking is enabled then print the coordinates
	 *	on the virtual screen that the wiimote is pointing to.
	 *
	 *	Also make sure that we see at least 1 dot.
	 */
	if (WIIUSE_USING_IR(wm)) {
		
		//evento del player [id1], verifico colpo
		if(WIIUSE_IS_LED_SET(wm,1)){
			confermaSparoPlayer();
		}else{
			//evento del robot [id2], verifico colpo
			confermaSparoRobot();
		}
	
//		int i = 0;
//		/* go through each of the 4 possible IR sources */
//		for (; i < 4; ++i) {
//			/* check if the source is visible */
//			if (wm->ir.dot[i].visible) {
//				printf("IR source %i: (%u, %u)\n", i, wm->ir.dot[i].x, wm->ir.dot[i].y);
//			}
//		}
//
//		printf("IR cursor: (%u, %u)\n", wm->ir.x, wm->ir.y);
//		printf("IR z distance: %f\n", wm->ir.z);
	}
	
}

void handle_ctrl_status(struct wiimote_t* wm) {
	printf("\n\n--- CONTROLLER STATUS [wiimote id %i] ---\n", wm->unid);

	printf("attachment:      %i\n", wm->exp.type);
	printf("speaker:         %i\n", WIIUSE_USING_SPEAKER(wm));
	printf("ir:              %i\n", WIIUSE_USING_IR(wm));
	printf("leds:            %i %i %i %i\n", WIIUSE_IS_LED_SET(wm, 1), WIIUSE_IS_LED_SET(wm, 2), WIIUSE_IS_LED_SET(wm, 3), WIIUSE_IS_LED_SET(wm, 4));
	printf("battery:         %f %%\n", wm->battery_level);
}

short any_wiimote_connected(wiimote** wm, int wiimotes) {
	int i;
	if (!wm) {
		return 0;
	}

	for (i = 0; i < wiimotes; i++) {
		if (wm[i] && WIIMOTE_IS_CONNECTED(wm[i])) {
			return 1;
		}
	}

	return 0;
}

/*
	comunicazione tramite seriale con xbee
*/

int settingSeriale(){
	struct termios options;
	int fd;
	//apro porta
	fd = open_port();
	//setting porta
	tcgetattr(fd, &options);
	
	/*baudrate*/
	cfsetispeed(&options, B9600);
	cfsetospeed(&options, B9600);
	options.c_cflag |= (CLOCAL | CREAD);
	/*character size*/
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;
	/*parity check*/
	options.c_cflag &= ~PARENB;
	options.c_cflag &= ~CSTOPB;
	/*canonical input*/
	options.c_lflag |= (ICANON | ECHO | ECHOE);
	/*processed output*/
	options.c_oflag |= OPOST;
	
	tcsetattr(fd, TCSANOW, &options);
	return fd;
}

int scriviSeriale(int fd){
	//scrivo carattere
	int n = write(fd, "1", 1);
	if (n < 0){
		fputs("write() of 1 bytes failed!\n", stderr);
	}
	return n;
}

int open_port(){
  int fd; /* File descriptor for the port */
  fd = open("/dev/ttyUSB0", O_RDWR | O_NOCTTY | O_NDELAY);
  if (fd == -1){
  	// Could not open the port
  	perror("open_port: Unable to open /dev/ttyUSB0 - ");
  }
  else{
    fcntl(fd, F_SETFL, 0);
  }
  return (fd);
}

