#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wiiuse.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>

#ifndef WIIUSE_WIN32
#include <unistd.h>                     /* for usleep */
#endif

#define WIIMOTENUMBER 1
#define ALLWIIMOTE 2
#define SEARCHTIME 10

void handle_event(struct wiimote_t* wm);
void handle_ctrl_status(struct wiimote_t* wm);
short any_wiimote_connected(wiimote** wm, int wiimotes);

int main (int argc, char* argv []){

	int number_of_wiimote=0;
	int connected=0;
	wiimote** wiimote_player;
	wiimote** wiimote_robot;

	//inizializzazione wiimote_player
	wiimote_player=wiiuse_init(WIIMOTENUMBER);
	printf("inizializzazione wiimote_player...\n");
	number_of_wiimote=wiiuse_find(wiimote_player, WIIMOTENUMBER, SEARCHTIME);
	printf("numero di wiimote trovati: %i \n", number_of_wiimote);
	connected=wiiuse_connect(wiimote_player,WIIMOTENUMBER);
	if(connected){
		printf("Connesso a %i wiimote_player di %i trovati.\n",connected, number_of_wiimote);	//modifico puntatore
	}else{
		printf("Connessione non riuscita con nessun wiimote.\n");
	}
	wiiuse_set_leds(wiimote_player[0], WIIMOTE_LED_1);
	

	//inizializzazione wiimote_robot
	wiimote_robot=wiiuse_init(WIIMOTENUMBER);
	printf("inizializzazione wiimote_robot...\n");
	number_of_wiimote=wiiuse_find(wiimote_robot, WIIMOTENUMBER, SEARCHTIME);
	printf("numero di wiimote trovati: %i\n", number_of_wiimote);
	connected=wiiuse_connect(wiimote_robot,WIIMOTENUMBER);
	if(connected){
		printf("Connesso a %i wiimote_robot di %i trovati.\n",connected, number_of_wiimote);
	}else{
		printf("Connessione non riuscita con nessun wiimote.\n");
	}
	wiiuse_set_leds(wiimote_robot[0], WIIMOTE_LED_2);
	
	
	//rumble x connessione
	wiiuse_rumble(wiimote_player[0], 1);
	wiiuse_rumble(wiimote_robot[0], 1);
	

#ifndef WIIUSE_WIN32
	usleep(200000);
#else
	Sleep(200);
#endif

	wiiuse_rumble(wiimote_player[0], 0);
	wiiuse_rumble(wiimote_robot[0], 0);

	
	//polling eventi
	while(any_wiimote_connected(wiimote_player, WIIMOTENUMBER)){
		if(wiiuse_poll(wiimote_player,WIIMOTENUMBER) || wiiuse_poll(wiimote_robot,WIIMOTENUMBER)){
				switch(wiimote_player[0]->event){
					case WIIUSE_EVENT: printf("Evento generico, verifichiamo... \n");
							   handle_event(wiimote_player[0]);
							   if(confermacolpo(wiimote_player)){
							   	printf("Visto! \n");
							   	
							   }else{
							   	printf("Non vedo 2 led...");
							   }
							   break;
					case WIIUSE_STATUS: printf("Richiesta evento di stato, ecco i dati... \n");
							    handle_ctrl_status(wiimote_player[0]);
							    break;
					default: break;
				}
				
				switch(wiimote_robot[0]->event){
					case WIIUSE_EVENT: printf("Evento generico, verifichiamo... \n");
							   handle_event(wiimote_player[0]);
							   break;
					case WIIUSE_STATUS: printf("Richiesta evento di stato, ecco i dati... \n");
							    handle_ctrl_status(wiimote_player[0]);
							    break;
					default: break;
				}
		}
	}
	return 0;
}

int confermacolpo(wiimote** wiimote){
	if((**wiimote).ir.num_dots==2){
		return 1;
	}
	return 0;
}

void handle_event(struct wiimote_t* wm) {
	printf("\n\n--- EVENT [id %i] ---\n", wm->unid);

	/* if a button is pressed, report it */
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_A)) {
		printf("A pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_B)) {
		printf("B pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_UP)) {
		printf("UP pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_DOWN))	{
		printf("DOWN pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_LEFT))	{
		printf("LEFT pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_RIGHT))	{
		printf("RIGHT pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_MINUS))	{
		printf("MINUS pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_PLUS))	{
		printf("PLUS pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_ONE)) {
		printf("ONE pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_TWO)) {
		printf("TWO pressed\n");
	}
	if (IS_PRESSED(wm, WIIMOTE_BUTTON_HOME))	{
		printf("HOME pressed\n");
	}

	/*
	 *	Pressing minus will tell the wiimote we are no longer interested in movement.
	 *	This is useful because it saves battery power.
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_MINUS)) {
//		wiiuse_motion_sensing(wm, 0);
//	}

	/*
	 *	Pressing plus will tell the wiimote we are interested in movement.
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_PLUS)) {
//		wiiuse_motion_sensing(wm, 1);
//	}

	/*
	 *	Pressing B will toggle the rumble
	 *
	 *	if B is pressed but is not held, toggle the rumble
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_B)) {
//		wiiuse_toggle_rumble(wm);
//	}

	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_UP)) {
		wiiuse_set_ir(wm, 1);
	}
	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_DOWN)) {
		wiiuse_set_ir(wm, 0);
	}

	/*
	 * Motion+ support
	 */
//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_ONE)) {
//		if (WIIUSE_USING_EXP(wm)) {
//			wiiuse_set_motion_plus(wm, 2);    // nunchuck pass-through
//		} else {
//			wiiuse_set_motion_plus(wm, 1);    // standalone
//		}
//	}

//	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_TWO)) {
//		wiiuse_set_motion_plus(wm, 0); // off
//	}

	/* if the accelerometer is turned on then print angles */
//	if (WIIUSE_USING_ACC(wm)) {
//		printf("wiimote roll  = %f [%f]\n", wm->orient.roll, wm->orient.a_roll);
//		printf("wiimote pitch = %f [%f]\n", wm->orient.pitch, wm->orient.a_pitch);
//		printf("wiimote yaw   = %f\n", wm->orient.yaw);
//	}

	/*
	 *	If IR tracking is enabled then print the coordinates
	 *	on the virtual screen that the wiimote is pointing to.
	 *
	 *	Also make sure that we see at least 1 dot.
	 */
	if (WIIUSE_USING_IR(wm)) {
		int i = 0;

		/* go through each of the 4 possible IR sources */
		for (; i < 4; ++i) {
			/* check if the source is visible */
			if (wm->ir.dot[i].visible) {
				printf("IR source %i: (%u, %u)\n", i, wm->ir.dot[i].x, wm->ir.dot[i].y);
			}
		}

		printf("IR cursor: (%u, %u)\n", wm->ir.x, wm->ir.y);
		printf("IR z distance: %f\n", wm->ir.z);
	}
	
	//pressione HOME esce
	if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_HOME)) {
		wiiuse_set_motion_plus(wm, 0); // off
	}

}

void handle_ctrl_status(struct wiimote_t* wm) {
	printf("\n\n--- CONTROLLER STATUS [wiimote id %i] ---\n", wm->unid);

	printf("attachment:      %i\n", wm->exp.type);
	printf("speaker:         %i\n", WIIUSE_USING_SPEAKER(wm));
	printf("ir:              %i\n", WIIUSE_USING_IR(wm));
	printf("leds:            %i %i %i %i\n", WIIUSE_IS_LED_SET(wm, 1), WIIUSE_IS_LED_SET(wm, 2), WIIUSE_IS_LED_SET(wm, 3), WIIUSE_IS_LED_SET(wm, 4));
	printf("battery:         %f %%\n", wm->battery_level);
}

short any_wiimote_connected(wiimote** wm, int wiimotes) {
	int i;
	if (!wm) {
		return 0;
	}

	for (i = 0; i < wiimotes; i++) {
		if (wm[i] && WIIMOTE_IS_CONNECTED(wm[i])) {
			return 1;
		}
	}

	return 0;
}
